'use strict';

var gulp = require('gulp');
var sass = require('gulp-sass');
var cssbeautify = require('gulp-cssbeautify');
var autoprefixer = require('gulp-autoprefixer');
var uglify = require('gulp-uglify');
var prettify = require('gulp-jsbeautifier');
var rename = require("gulp-rename");
var cssmin = require('gulp-cssmin');
 
gulp.task('sass', function () {
	return gulp.src('./src/sass/**/*.scss')
		.pipe(sass.sync().on('error', sass.logError))
		.pipe(cssbeautify())
		.pipe(autoprefixer())
		.pipe(rename({
			basename: "jquery.mobilemenu"
		}))
		.pipe(gulp.dest('./dist/css'))
		.pipe(rename({
			basename: "jquery.mobilemenu",
		  suffix: ".min"
		}))
		.pipe(gulp.dest('./dist/css'));
});

gulp.task('js', function () {
	return gulp.src('./src/js/**/*.js')
		.pipe(prettify())
		.pipe(rename({
			basename: "jquery.mobilemenu"
		}))
		.pipe(gulp.dest('./dist/js'))
		.pipe(uglify())
		.pipe(rename({
			basename: "jquery.mobilemenu",
		  suffix: ".min"
		}))
		.pipe(gulp.dest('./dist/js'));
});
 
gulp.task('watch', function () {
	gulp.watch('./src/sass/**/*.scss', ['sass']);
	gulp.watch('./src/js/**/*.js', ['js']);
});